<template>
    <QuillEditor
        :id="idInput"
        ref="editor"
        :options="options"
        @update:content="onUpdateContent"
    />
</template>

<script>
import { Quill, QuillEditor } from "@vueup/vue-quill";
import "@vueup/vue-quill/dist/vue-quill.snow.css";

let AlignClass = Quill.import("attributors/style/align");
Quill.register(AlignClass, true);

export default {
    components: {
        QuillEditor
    },
    props: {
        content: {
            type: String,
            required: true
        },
        readOnly: {
            type: Boolean,
            default: false
        },
        idInput: {
            type: String,
            default: ""
        },
        height: {
            type: String,
            default: "300"
        },
        placeholder: {
            type: String,
            default: "Nhập nội dung vào đây..."
        }
    },
    data() {
        return {
            options: {
                modules: {
                    toolbar: [
                        [{ header: [1, 2, 3, 4, 5, 6, false] }],
                        ["bold", "italic", "underline", "strike"],
                        ["blockquote", "code-block"],
                        [{ header: 1 }, { header: 2 }],
                        [{ list: "ordered" }, { list: "bullet" }],
                        [{ script: "sub" }, { script: "super" }],
                        [{ indent: "-1" }, { indent: "+1" }],
                        [{ direction: "rtl" }],
                        [{ color: [] }, { background: [] }],
                        [{ align: [] }],
                        ["link", "image", "video"],
                        ["clean"]
                    ]
                },
                placeholder: this.placeholder,
                readOnly: this.readOnly,
                theme: "snow"
            }
        };
    },
    mounted() {
        this.$nextTick(function() {
            this.$refs.editor.setHTML(this.content);
        });

        const style = document.createElement("style");
        style.innerHTML = `${
            this.idInput ? "." + this.idInput : ""
        }.ql-container {height: ${this.height}px;}`;
        document.querySelector("body").appendChild(style);
    },
    methods: {
        onUpdateContent() {
            const html = this.$refs.editor.getHTML();
            this.$emit("update:content", html);
        }
    }
    /** bỏ vì nó set lại liên tục gây ra lỗi con trỏ nhảy về đầu dòng khi viết chữ */
    // watch: {
    //   content: function(val) {
    //     this.$refs.editor.setHTML(val);
    //   }
    // }
};
</script>

<style lang="scss">
// .ql-container {
//   height: 300px;
// }
div[data-mode="link"],
div[data-mode="video"] {
    z-index: 99999;
}
</style>
